import time


class CFClient(object):
    def __init__(self, boto_session, boto_config=None, endpoint_url=None):
        """

        @param boto_session: Preexisting boto session
        @param boto_config: optional boto config for the sns client
        """

        self.cf_client = boto_session.client(
            "cloudfront", config=boto_config, endpoint_url=endpoint_url
        )

    def create_invalidation(self, distribution_id, invalidation_path_list):
        return self.cf_client.create_invalidation(
            DistributionId=distribution_id,
            InvalidationBatch={
                "Paths": {
                    "Quantity": len(invalidation_path_list),
                    "Items": invalidation_path_list,
                },
                "CallerReference": str(time.time()).replace(".", ""),
            },
        )
