from __future__ import division
from past.utils import old_div
from tic.shared.scoring.score_calulator_base import ScoreCalculatorBase
from tic.shared.utils.utcdatetime import get_utc_now_string

# This has never been incremented...
_binary_algorithm_version = 1


class BinaryScoreCalculator(ScoreCalculatorBase):
    def calculate(self, reputation_score):
        """
        Default temporary implementation that just calculates without weights
        """
        scores = [part["score"] for part in reputation_score["parts"]]
        if len(scores) > 0:
            reputation_score["range"] = max(scores) - min(scores)
            reputation_score["last_update"] = get_utc_now_string()
            reputation_score["version"] = self.version

            reputation_score["mean"] = old_div(sum(scores), len(scores))
            reputation_score["mode"] = max(set(scores), key=scores.count)

            reputation_score["confidence"] = 0
            reputation_score["median"] = 0
            reputation_score["stddev"] = 0

            # Updated to use the mean as the score - TPLAT-655
            reputation_score["value"] = reputation_score["mean"]

    @property
    def version(self):
        return _binary_algorithm_version
