from tic.shared.dto import Dto
from tic.shared.ubs.enums.analysis.stage import UbsAnalysisStage
from tic.shared.ubs.enums.analysis.status import UbsAnalysisStatus


class StageSummary(Dto):
    decode_names = {
        "stage_version": "version",
        "stage_status": "status",
        "stage_name": "name",
    }
    encode_names = {
        "version": "stage_version",
        "status": "stage_status",
        "name": "stage_name",
    }

    decode_settings = {
        "name": lambda x: UbsAnalysisStage[x],
        "status": lambda x: UbsAnalysisStatus[x],
        "version": lambda x: tuple(int(y) for y in x.split(".")),
    }
    encode_settings = {
        "name": lambda x: x.name,
        "status": lambda x: x.name,
        "version": lambda x: ".".join((str(y) for y in x)),
    }

    def __init__(
        self,
        name: UbsAnalysisStage = None,
        status: UbsAnalysisStatus = UbsAnalysisStatus.NOT_STARTED,
        version: tuple = None,
    ):
        self.name = name
        self.status = status
        self.version = version
