from ...ubs.util import hash_to_binary


class DeviceInsert(object):
    def __init__(self, sha256, org_key, device_id, device_name, first_seen):
        self.sha256 = sha256
        self.org_key = org_key
        self.device_id = device_id
        self.device_name = device_name
        self.first_seen = first_seen

    def to_tuple(self):
        return (
            hash_to_binary(self.sha256),
            self.org_key,
            self.device_id,
            self.device_name,
            self.first_seen,
        )

    def __eq__(self, other):
        if not isinstance(other, DeviceInsert):
            return False
        return (
            self.sha256 == other.sha256
            and self.org_key == other.org_key
            and self.device_id == other.device_id
            and self.device_name == other.device_name
            and self.first_seen == other.first_seen
        )

    def __hash__(self):
        return hash(self.to_tuple())
