from PIL import Image
import base64
import io


def get_image_type(b64encoded_str):
    image = Image.open(io.BytesIO(base64.b64decode(b64encoded_str)))
    return image.format


def get_b64encoded_str_from_image_file(file_path):
    with open(file_path, "rb") as image_file:
        encoded_string = base64.b64encode(image_file.read())

    return encoded_string


def get_image_size(file_path):
    image = Image.open(file_path)
    return image.size
